local LightningTimer = CreateFrame("Frame")
local LightningStart = CreateFrame("Frame")
local startTime = GetTime()

function LightningTimer:Greasy(event)
	local _, e, _, _, _, _, _, _, _, _, _, spellId, _, _, _, a = CombatLogGetCurrentEventInfo()
	eventType = e or "nil"
	if spellId ~= 257829 or not string.find(eventType, "SPELL_AURA_REMOVED")then
		return
	end
	local amount = a or 0
	local chatType = ""
	if IsInGroup() then
		chatType = "PARTY"
	else
		chatType = "SAY"
	end
	SendChatMessage("LightningTimer: Greasy stacks left: " .. amount, chatType)
	if amount == 0 then
		local finishTime = GetTime()
		local duration = finishTime - startTime - 9.194
		SendChatMessage("LightningTimer: It took " .. TimeToTwoDp(duration) .. " seconds to catch the piggy", chatType)
		LightningTimer:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		if LightningGreasyRecord == nil then
			SendChatMessage("LightningTimer: This is a new personal best!", chatType)
			LightningGreasyRecord = duration
			return
		elseif LightningGreasyRecord > duration then
			SendChatMessage("LightningTimer: This is a new personal best! Previous best was " .. TimeToTwoDp(LightningGreasyRecord) .. " seconds", chatType)
			LightningGreasyRecord = duration
			return
		else
			SendChatMessage("LightningTimer: Personal best is " .. TimeToTwoDp(LightningGreasyRecord) .. " seconds", chatType)
			return
		end
	end
end

function TimeToTwoDp(longTime)
	return string.sub(tostring(longTime), 0, 5)
end
function LightningTimer:GreasyStart(event, ...)
	if GetZoneText() ~= "Freehold" then
		return 
	end
	local chatMsg, chatSender = ...
	if chatSender == "Gurgthock" and string.find(chatMsg, "It's a greased up pig?") then
		startTime = GetTime()
		LightningTimer:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		LightningTimer:SetScript("OnEvent", LightningTimer.Greasy)
	end
end

LightningStart:RegisterEvent("CHAT_MSG_MONSTER_SAY")
LightningStart:SetScript("OnEvent", LightningTimer.GreasyStart)